Index: trunk/src/VBox/Frontends/VBoxHeadless/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/Makefile.kmk	(revision 5999)
+++ trunk/src/VBox/Frontends/VBoxHeadless/Makefile.kmk	(revision 6000)
@@ -7,6 +7,11 @@
 # Copyright (C) 2006-2007 innotek GmbH
 #
-# innotek GmbH confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 #
 
Index: trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp	(revision 5999)
+++ trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp	(revision 6000)
@@ -8,6 +8,11 @@
  * Copyright (C) 2006-2007 innotek GmbH
  *
- * innotek GmbH confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.h
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.h	(revision 5999)
+++ trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.h	(revision 6000)
@@ -8,6 +8,11 @@
  * Copyright (C) 2006-2007 innotek GmbH
  *
- * innotek GmbH confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.cpp	(revision 5999)
+++ trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.cpp	(revision 6000)
@@ -8,6 +8,11 @@
  * Copyright (C) 2006-2007 innotek GmbH
  *
- * innotek GmbH confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.h
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.h	(revision 5999)
+++ trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.h	(revision 6000)
@@ -8,6 +8,11 @@
  * Copyright (C) 2006-2007 innotek GmbH
  *
- * innotek GmbH confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/Makefile.kmk	(revision 5999)
+++ trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/Makefile.kmk	(revision 6000)
@@ -7,6 +7,11 @@
 # Copyright (C) 2006-2007 innotek GmbH
 #
-# innotek GmbH confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 #
 
Index: trunk/src/VBox/Frontends/VBoxHeadless/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/testcase/Makefile.kmk	(revision 5999)
+++ trunk/src/VBox/Frontends/VBoxHeadless/testcase/Makefile.kmk	(revision 6000)
@@ -7,6 +7,11 @@
 # Copyright (C) 2006-2007 innotek GmbH
 #
-# innotek GmbH confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 #
 
Index: trunk/src/VBox/Frontends/VBoxHeadless/testcase/tstHeadless.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/testcase/tstHeadless.cpp	(revision 5999)
+++ trunk/src/VBox/Frontends/VBoxHeadless/testcase/tstHeadless.cpp	(revision 6000)
@@ -8,6 +8,11 @@
  * Copyright (C) 2006-2007 innotek GmbH
  *
- * innotek GmbH confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 